unit ListCfg;

{ Listeur de fichiers avec configuration imprimante }
{ Configuration des imprimantes }

INTERFACE

uses
  crt,
  Turbolib,
  Turboftr,
  ListGlob;

procedure Menu_Config_Imp;
function ChoixCfg(Var Config:CfgImp): byte;

{----------------------------------------------------------------------------}

IMPLEMENTATION

{----------------------------------------------------------------------------}

procedure AfficheTitreCfg;

var
  X,Y : byte;

  procedure Affi(Titre : str80);

  Begin
    gotoXY(X,Y);
    write(Titre);
    inc(Y);
  End;


Begin
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  X := 4;
  Y := 5;
  Affi(' Nom :');
  inc(Y);

  Y := 8;
  Affi(' Initial. :');
  Affi(' RAZ      :');
  Affi(' FinLigne :');
  Affi(' SautLigne:');
  Affi(' NouvPage :');
  Affi(' LongPage :');
  Affi(' France   :');
  Affi(' USA      :');
  Affi(' Inter1/6 :');
  Affi(' Inter1/8 :');
  Affi(' InterN/72:');

  inc(Y);
  Affi(' Mode imp.:');

  X := 33;
  Y := 8;
  Affi(' Pica      :');
  Affi(' Elite     :');
  Affi(' Proportion:');
  Affi(' Compresse :');
  Affi(' Gras      :');

  X := 61;
  Y := 8;
  Affi(' DblFrappe :');
  Affi(' Expanse   :');
  Affi(' Italique  :');
  Affi(' Souligne  :');

  Y := 14;
  gotoXY(48,Y);
  write(' Marche ');
  gotoXY(64,Y);
  write(' Arret  ');
  inc(Y);

  X := 33;
  Affi(' Courrier  :');
  Affi(' ExpanseLig:');
  Affi(' Surligne  :');
End;

{----------------------------------------------------------------------------}

procedure AffiNom(Texte : string);

Begin
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  gotoXY(10,5);
  write(' ',Texte,' ');
End;

{----------------------------------------------------------------------------}

procedure AffiChaine(LaChaine : Chaine;Var X,Y : byte);

var N : byte;

Begin
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  gotoXY(X,Y);
  write(' ');
  for N := 1 to NbCarChaine do
  Begin
    if LaChaine[N] in [0..9] then write('  ',LaChaine[N],' ');
    if LaChaine[N] in [10..99] then write(' ',LaChaine[N],' ');
    if LaChaine[N] in [100..254] then write(LaChaine[N],' ');
    if LaChaine[N] = 255 then write('   ',' ');
  End;
  inc(Y);
End;

{----------------------------------------------------------------------------}

procedure AffiValeur(LaValeur : byte;Var X,Y : byte);

Begin
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  gotoXY(X,Y);
  write(' ');
  if LaValeur in [0..9] then write('  ',LaValeur,' ');
  if LaValeur in [10..99] then write(' ',LaValeur,' ');
  if LaValeur in [100..254] then write(LaValeur,' ');
  if LaValeur = 255 then write('   ',' ');
  inc(Y);
End;

{----------------------------------------------------------------------------}

procedure AffiBascule(LaBascule : Bascule;Var X,Y : byte);

var N : byte;

Begin
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  gotoXY(X,Y);
  write(' ');
  for N := 1 to NbCarChaine do
  Begin
    if LaBascule.On[N] in [0..9] then write('  ',LaBascule.On[N],' ');
    if LaBascule.On[N] in [10..99] then write(' ',LaBascule.On[N],' ');
    if LaBascule.On[N] in [100..254] then write(LaBascule.On[N],' ');
    if LaBascule.On[N] = 255 then write('   ',' ');
  End;
  gotoXY((X+16),Y);
  write('');
  for N := 1 to NbCarChaine do
  Begin
    if LaBascule.Off[N] in [0..9] then write('   ',LaBascule.Off[N]);
    if LaBascule.Off[N] in [10..99] then write('  ',LaBascule.Off[N]);
    if LaBascule.Off[N] in [100..254] then write(' ',LaBascule.Off[N]);
    if LaBascule.Off[N] = 255 then write('    ');
  End;
  inc(Y);
End;

{----------------------------------------------------------------------------}

procedure AffiBascule2(LaBascule : Bascule2;Var X,Y : byte);

var N : byte;

Begin
  gotoXY(X - 12,Y);
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  write(' ',LaBascule.Def,':');
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  write(' ');
  for N := 1 to NbCarChaine do
  Begin
    if LaBascule.On[N] in [0..9] then write('  ',LaBascule.On[N],' ');
    if LaBascule.On[N] in [10..99] then write(' ',LaBascule.On[N],' ');
    if LaBascule.On[N] in [100..254] then write(LaBascule.On[N],' ');
    if LaBascule.On[N] = 255 then write('   ',' ');
  End;
  gotoXY((X+16),Y);
  write('');
  for N := 1 to NbCarChaine do
  Begin
    if LaBascule.Off[N] in [0..9] then write('   ',LaBascule.Off[N]);
    if LaBascule.Off[N] in [10..99] then write('  ',LaBascule.Off[N]);
    if LaBascule.Off[N] in [100..254] then write(' ',LaBascule.Off[N]);
    if LaBascule.Off[N] = 255 then write('    ');
  End;
  inc(Y);
End;

{----------------------------------------------------------------------------}

procedure AfficheCfg(Config : CfgImp);

var
  X,Y,Z : byte;

Begin
  with Config do
  Begin
    AfficheTitreCfg;

    AffiNom(Nom);

    X := 15;
    Y := 8;
    AffiChaine(Initial,X,Y);
    AffiChaine(RAZ,X,Y);
    AffiChaine(FinLigne,X,Y);
    AffiChaine(SautLigne,X,Y);
    AffiChaine(NouvPage,X,Y);
    AffiChaine(LongPage,X,Y);
    AffiChaine(France,X,Y);
    AffiChaine(USA,X,Y);
    AffiChaine(Inter1_6,X,Y);
    AffiChaine(Inter1_8,X,Y);
    AffiChaine(InterN_72,X,Y);
    inc(Y);
    AffiChaine(ModeImp,X,Y);


    X := 45;
    Y := 8;
    AffiValeur(Pica,X,Y);
    AffiValeur(Elite,X,Y);
    AffiValeur(Proportion,X,Y);
    AffiValeur(Compresse,X,Y);
    AffiValeur(Gras,X,Y);

    X := 73;
    Y := 8;
    AffiValeur(DblFrappe,X,Y);
    AffiValeur(Expanse,X,Y);
    AffiValeur(Italique,X,Y);
    AffiValeur(Souligne,X,Y);

    X := 45;
    Y := 15;
    AffiBascule(Courrier,X,Y);
    AffiBascule(ExpanseLig,X,Y);
    AffiBascule(Surligne,X,Y);

    for Z := 1 to NbBasculeSp do AffiBascule2(Special[Z],X,Y);
  End;
End;

{----------------------------------------------------------------------------}

procedure SaisieBascule(Titre : str80;Var LaBascule : Bascule;Var X,Y : byte);

var
  Z   : byte;
  Tmp : str80;

Begin
  gotoXY(X,Y);
  for Z := 1 to NbCarChaine do
    Begin
      CoulFond(CFMenu);
      CoulTexte(CTMenu);
      Entier := LaBascule.On[Z];
      str(Z,Tmp);
      Tmp := ' ' + Titre + ' Marche n' + Tmp + ':';
      Saisie(4,23,3,2,CFSaisie,CTSaisie,Tmp);
      if Abandon then exit;
      LaBascule.On[Z] := Entier;
      CoulFond(CFSaisie);
      CoulTexte(CTSaisie);
      if LaBascule.On[Z] in [0..9] then write('   ',LaBascule.On[Z]);
      if LaBascule.On[Z] in [10..99] then write('  ',LaBascule.On[Z]);
      if LaBascule.On[Z] in [100..254] then write(' ',LaBascule.On[Z]);
      if LaBascule.On[Z] = 255 then write('    ');
    End;

  gotoXY((X+17),Y);
  for Z := 1 to NbCarChaine do
    Begin
      CoulFond(CFMenu);
      CoulTexte(CTMenu);
      Entier := LaBascule.Off[Z];
      str(Z,Tmp);
      Tmp := ' ' + Titre + ' Arrt  n' + Tmp + ':';
      Saisie(4,23,3,2,CFSaisie,CTSaisie,Tmp);
      if Abandon then exit;
      LaBascule.Off[Z] := Entier;
      CoulFond(CFSaisie);
      CoulTexte(CTSaisie);
      if LaBascule.Off[Z] in [0..9] then write('   ',LaBascule.Off[Z]);
      if LaBascule.Off[Z] in [10..99] then write('  ',LaBascule.Off[Z]);
      if LaBascule.Off[Z] in [100..254] then write(' ',LaBascule.Off[Z]);
      if LaBascule.Off[Z] = 255 then write('    ');
    End;

    inc(Y);
    UnBip;
End;

{----------------------------------------------------------------------------}

procedure SaisieBascule2(Titre : str80;Var LaBascule : Bascule2;Var X,Y : byte);

var
  Z   : byte;
  Tmp : str80;

Begin
  gotoXY(X - 12,Y);
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  Alpha := LaBascule.Def;
  Tmp := Titre + '(Nom):';
  Saisie(4,23,10,1,CFSaisie,CTSaisie,Tmp);
  if Abandon then exit;
  LaBascule.Def := ElargiADte(Alpha,10);
  write(' ',LaBascule.Def,':');

  gotoXY(X,Y);
  for Z := 1 to NbCarChaine do
    Begin
      CoulFond(CFMenu);
      CoulTexte(CTMenu);
      Entier := LaBascule.On[Z];
      str(Z,Tmp);
      Tmp := ' ' + Titre + ' Marche n' + Tmp + ':';
      Saisie(4,23,3,2,CFSaisie,CTSaisie,Tmp);
      if Abandon then exit;
      LaBascule.On[Z] := Entier;
      CoulFond(CFSaisie);
      CoulTexte(CTSaisie);
      if LaBascule.On[Z] in [0..9] then write('   ',LaBascule.On[Z]);
      if LaBascule.On[Z] in [10..99] then write('  ',LaBascule.On[Z]);
      if LaBascule.On[Z] in [100..254] then write(' ',LaBascule.On[Z]);
      if LaBascule.On[Z] = 255 then write('    ');
    End;

  gotoXY((X+17),Y);
  for Z := 1 to NbCarChaine do
    Begin
      CoulFond(CFMenu);
      CoulTexte(CTMenu);
      Entier := LaBascule.Off[Z];
      str(Z,Tmp);
      Tmp := ' ' + Titre + ' Arrt  n' + Tmp + ':';
      Saisie(4,23,3,2,CFSaisie,CTSaisie,Tmp);
      if Abandon then exit;
      LaBascule.Off[Z] := Entier;
      CoulFond(CFSaisie);
      CoulTexte(CTSaisie);
      if LaBascule.Off[Z] in [0..9] then write('   ',LaBascule.Off[Z]);
      if LaBascule.Off[Z] in [10..99] then write('  ',LaBascule.Off[Z]);
      if LaBascule.Off[Z] in [100..254] then write(' ',LaBascule.Off[Z]);
      if LaBascule.Off[Z] = 255 then write('    ');
    End;

    inc(Y);
    UnBip;
End;

{----------------------------------------------------------------------------}

procedure SaisieChaine(Titre : str80;Var LaChaine : Chaine;Var X,Y : byte);

var
  Z   : byte;
  Tmp : str80;

Begin
  gotoXY(X,Y);
  for Z := 1 to NbCarChaine do
    Begin
      CoulFond(CFMenu);
      CoulTexte(CTMenu);
      Entier := LaChaine[Z];
      str(Z,Tmp);
      Tmp := ' ' + Titre + ' n' + Tmp + ' :';
      Saisie(4,23,3,2,CFSaisie,CTSaisie,Tmp);
      if Abandon then exit;
      LaChaine[Z] := Entier;
      CoulFond(CFSaisie);
      CoulTexte(CTSaisie);
      if LaChaine[Z] in [0..9] then write('   ',LaChaine[Z]);
      if LaChaine[Z] in [10..99] then write('  ',LaChaine[Z]);
      if LaChaine[Z] in [100..254] then write(' ',LaChaine[Z]);
      if LaChaine[Z] = 255 then write('    ');
    End;

    inc(Y);
    UnBip;
End;

{----------------------------------------------------------------------------}

procedure SaisieValeur(Titre : str80;Var LaValeur : byte;Var X,Y : byte);

var
  Tmp : str80;

Begin
  gotoXY(X,Y);
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  Entier := LaValeur;
  Tmp := ' ' + Titre + ' :';
  Saisie(4,23,3,2,CFSaisie,CTSaisie,Tmp);
  if Abandon then exit;
  LaValeur := Entier;
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  if LaValeur in [0..9] then write('   ',LaValeur);
  if LaValeur in [10..99] then write('  ',LaValeur);
  if LaValeur in [100..254] then write(' ',LaValeur);
  if LaValeur = 255 then write('    ');
  inc(Y);
  UnBip;
End;

{----------------------------------------------------------------------------}

procedure SaisieCfg(Var Config : CfgImp);

var
  X,Y,Z : byte;
  Temp : str80;

  procedure EffaceLigne;

  var w : byte;

  Begin
    CoulFond(CFond);
    gotoXY(4,23);
    for W := 1 to 40 do write(' ');
  End;

Begin
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  with Config do
  Begin
    alpha := Nom;
    Saisie(4,23,NbCarNom,1,CFSaisie,CTSaisie,' Nom :');
    if abandon then exit;
    Nom := alpha;
    Nom := ElargiADte(Nom,NbCarNom);
    AffiNom(Nom);

    X := 15;
    Y := 8;
    SaisieChaine('Initialisation imprimante',Initial,X,Y);
    if Abandon then exit;
    SaisieChaine('Remise  zro            ',RAZ,X,Y);
    if Abandon then exit;
    SaisieChaine('Fin de ligne             ',FinLigne,X,Y);
    if Abandon then exit;
    SaisieChaine('Saut de ligne            ',SautLigne,X,Y);
    if Abandon then exit;
    SaisieChaine('Nouvelle page            ',NouvPage,X,Y);
    if Abandon then exit;
    SaisieChaine('Longueur page (lignes)   ',LongPage,X,Y);
    if Abandon then exit;
    SaisieChaine('Code FRANCE              ',France,X,Y);
    if Abandon then exit;
    SaisieChaine('Code USA                 ',USA,X,Y);
    if Abandon then exit;
    SaisieChaine('Interligne 1/6           ',Inter1_6,X,Y);
    if Abandon then exit;
    SaisieChaine('Interligne 1/8           ',Inter1_8,X,Y);
    if Abandon then exit;
    SaisieChaine('Interligne n/72          ',InterN_72,X,Y);
    if Abandon then exit;
    inc(Y);
    SaisieChaine('Mode d''impression        ',ModeImp,X,Y);
    if Abandon then exit;

    EffaceLigne;

    X := 45;
    Y := 8;
    SaisieValeur('Impression Pica       ',Pica,X,Y);
    if Abandon then exit;
    SaisieValeur('Impression Elite      ',Elite,X,Y);
    if Abandon then exit;
    SaisieValeur('Proportionnelle       ',Proportion,X,Y);
    if Abandon then exit;
    SaisieValeur('Compresse             ',Compresse,X,Y);
    if Abandon then exit;
    SaisieValeur('Gras                  ',Gras,X,Y);
    if Abandon then exit;

    X := 73;
    Y := 8;
    SaisieValeur('Double frappe         ',DblFrappe,X,Y);
    if Abandon then exit;
    SaisieValeur('Expansion             ',Expanse,X,Y);
    if Abandon then exit;
    SaisieValeur('Italique              ',Italique,X,Y);
    if Abandon then exit;
    SaisieValeur('Soulignement          ',Souligne,X,Y);
    if Abandon then exit;

    X := 45;
    Y := 15;
    SaisieBascule('Qualit courrier      ',Courrier,X,Y);
    if Abandon then exit;
    SaisieBascule('Expansion 1 ligne     ',ExpanseLig,X,Y);
    if Abandon then exit;
    SaisieBascule('Surlignement          ',Surligne,X,Y);
    if Abandon then exit;

    for Z := 1 to NbBasculeSp do
    Begin
      str(Z,Temp);
      Temp := 'Fonction spciale '+ Temp + '    ';
      SaisieBascule2(Temp,Special[Z],X,Y);
      if Abandon then exit;
    End;
  End;
  CoulFond(CFond);
  CoulTexte(CTexte);
  Temp := ' ';
  Temp := ElargiADte(Temp,40);
  gotoXY(4,23);
  write(Temp);
End;

{----------------------------------------------------------------------------}

procedure SauverConfig(Config : CfgImp);

var
  ConfigTmp : CfgImp;
  Nom_Fichier : str80;

Begin
  Nom_Fichier := RepPrg + 'LISTER.CFG';
  assign(Fichier_Cfg,Nom_Fichier);
  if FicExiste(Nom_Fichier) then
  Begin
    reset(Fichier_Cfg);
    while not Eof(Fichier_Cfg) do read(Fichier_Cfg,ConfigTmp);
  End
  else rewrite(Fichier_Cfg);
  write(Fichier_Cfg,Config);
  close(Fichier_Cfg);
End;

{----------------------------------------------------------------------------}

procedure MettreAJourConfig(Config : CfgImp;Position :byte);

var
  ConfigTmp : CfgImp;
  Nom_Fichier : str80;

Begin
  Nom_Fichier := RepPrg + 'LISTER.CFG';
  assign(Fichier_Cfg,Nom_Fichier);
  if FicExiste(Nom_Fichier) then
  Begin
    reset(Fichier_Cfg);
    seek(Fichier_Cfg,Position);
  End
  else rewrite(Fichier_Cfg);
  write(Fichier_Cfg,Config);
  close(Fichier_Cfg);
End;

{----------------------------------------------------------------------------}

procedure NouvelleConfig(var Config : CfgImp);

  procedure InitChaine(Var LaChaine : Chaine);

  var N : byte;

  Begin
    for N := 1 to NbCarChaine do LaChaine[N] := 255;
  End;

  procedure InitMode(Var LeMode : byte);

  Begin
    LeMode := 255;
  End;

  procedure InitBascule(Var LaBascule : Bascule);

  var N : byte;

  Begin
    for N := 1 to NbCarChaine do
    Begin
      LaBascule.On[N] := 255;
      LaBascule.Off[N] := 255;
    End;
  End;

  procedure InitBascule2(Var LaBascule : Bascule2);

  var N : byte;

  Begin
    for N := 1 to NbCarChaine do
    Begin
      LaBascule.Def := '??????????';
      LaBascule.On[N] := 255;
      LaBascule.Off[N] := 255;
    End;
  End;

var Z : byte;

Begin
  with Config do
  Begin
    Nom :='';
    Nom := ElargiADte(Nom,NbCarNom);

    InitChaine(Initial);
    InitChaine(RAZ);
    InitChaine(FinLigne);
    InitChaine(SautLigne);
    InitChaine(NouvPage);
    InitChaine(LongPage);
    InitChaine(France);
    InitChaine(USA);
    InitChaine(Inter1_6);
    InitChaine(Inter1_8);
    InitChaine(InterN_72);

    InitChaine(ModeImp);
    InitMode(Pica);
    InitMode(Elite);
    InitMode(Proportion);
    InitMode(Compresse);
    InitMode(Gras);
    InitMode(DblFrappe);
    InitMode(Expanse);
    InitMode(Italique);
    InitMode(Souligne);

    InitBascule(Courrier);
    InitBascule(ExpanseLig);
    InitBascule(Surligne);

    for Z := 1 to NbBasculeSp do InitBascule2(Special[Z]);
  End;
End;

{----------------------------------------------------------------------------}

function ChoixCfg(Var Config:CfgImp): byte;

var
  W : byte;
  Temp : str40;
  ConfigTmp : CfgImp;
  LeChoix : TypChoix;
  Nom_Fichier : str80;
  T1,T2 : str80;

Begin
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  Abandon := false;
  for W := 1 to 255 do
  Begin
    new(LeChoix[W]);
    LeChoix[W]^ := '';
  End;
  Nom_Fichier := RepPrg + 'LISTER.CFG';
  assign(Fichier_Cfg,Nom_Fichier);
  if FicExiste(Nom_Fichier) then
  Begin
    reset(Fichier_Cfg);
    W := 0;
    while not Eof(Fichier_Cfg) do
    Begin
      inc(W);
      read(Fichier_Cfg,ConfigTmp);
      LeChoix[W]^ := ConfigTmp.Nom;
    End;
    close(Fichier_Cfg);
    dec(W);
    Resultat := 0;
    if Choix(27,10,4,10,Resultat,LeChoix) then
    Begin
      reset(Fichier_Cfg);
      seek(Fichier_Cfg,(Resultat - 1));
      read(Fichier_Cfg,Config);
    End
    else Abandon := true;
  End
  else
  Begin
    W := 0;
    Alerte('Fichier LISTER.CFG introuvable !');
    Abandon := true;
  End;
  ChoixCfg := W;
End;

{----------------------------------------------------------------------------}

procedure Edition;

var
  Imp : CfgImp;
  Position : integer;
  Sauve : boolean;

Begin
  Fond;
  Message(CTTitre,CFTitre,' Edition configuration imprimante ',3,false);
  Position := ChoixCfg(Imp);
  if not Abandon then
  Begin
    AfficheCfg(Imp);
    SaisieCfg(Imp);
    if not Abandon then
    Begin
      Sauve := DialogueBout('Sauvegarder ?','Oui','Non');
      if Sauve then MettreAJourConfig(Imp,Position);
    End;
  End;
End;

{----------------------------------------------------------------------------}

procedure Creation;

var
  Imp : CfgImp;
  Sauve : boolean;

Begin
  Fond;
  Message(CTTitre,CFTitre,' Cration configuration imprimante ',3,false);
  NouvelleConfig(Imp);
  AfficheCfg(Imp);
  SaisieCfg(Imp);
  if not Abandon then
  Begin
    Sauve := DialogueBout('Sauvegarder ?','Oui','Non');
    if Sauve then SauverConfig(Imp);
  End;
End;

{----------------------------------------------------------------------------}

procedure Suppression_Fichier(Pos : integer);

var
  Imp : CfgImp;
  F_Tempo : FConfig;
  NF_Tempo,Nom_Fichier : str80;
  Ligne : integer;

Begin
  NF_Tempo := RepPrg + 'LISTER.$$$';
  assign(F_Tempo,NF_Tempo);
  rewrite(F_Tempo);
  Nom_Fichier := RepPrg + 'LISTER.CFG';
  assign(Fichier_Cfg,Nom_Fichier);
  reset(Fichier_Cfg);
  Ligne := 0;
  while not Eof(Fichier_Cfg) do
  Begin
    read(Fichier_Cfg,Imp);
    if Ligne <> Pos then write(F_Tempo,Imp);
    inc(Ligne);
  End;
  close(F_Tempo);
  close(Fichier_Cfg);
  erase(Fichier_Cfg);
  rename(F_Tempo,'LISTER.CFG');
End;

{----------------------------------------------------------------------------}

procedure Suppression;

var
  Imp : CfgImp;
  Position : integer;
  Supp : boolean;


Begin
  Fond;
  Message(CTTitre,CFTitre,' Suppression configuration imprimante ',3,false);
  Position := ChoixCfg(Imp);
  if not Abandon then
  Begin
    AfficheCfg(Imp);
    Supp := not DialogueBout('Suppression ?','Non','Oui');
    if Supp then Suppression_Fichier(Position);
  End;
End;

{----------------------------------------------------------------------------}

procedure Menu_Config_Imp;

var
  N : byte;

Begin
  Fin := false;
  repeat
    Fond;
    Message(CTTitre,CFTitre,' Configuration imprimantes ',3,false);
    Message(CTMenu,CFMenu,'  ESC = retour au menu prcdent  ',22,false);
    CoulFond(CFMenu);
    CoulTexte(CTMenu);
    Choix_Menu[1]^ := ' Edition     ';
    Choix_Menu[2]^ := ' Cration    ';
    Choix_Menu[3]^ := ' Suppression ';
    for N := 4 to NbChoixMnu do Choix_Menu[N]^ := '';
    Resultat := 0;
    if not Choix(31,10,3,NbChoixMnu,Resultat,Choix_Menu) then Fin := true;
    case Resultat of
      1 : Edition;
      2 : Creation;
      3 : Suppression;
    end;
  until Fin;
  Fin := false;
End;

{----------------------------------------------------------------------------}

Begin

End.