unit ListGlob;

{ Listeur de fichiers avec configuration imprimante }
{ Routines globales }


INTERFACE

uses
  crt,
  Turbolib,
  Turbotxt,
  Turboftr;

const
  CFond = bleu; {couleur fond}
  CTexte = blanc; {couleur texte}
  CFTitre = rouge; {couleur fond titres}
  CTTitre = jaune; {couleur texte titres}
  CFMenu = bleuciel; {couleur fond menus}
  CTMenu = noir; {couleur texte menus}
  CFSaisie = grisclair; {couleur fond saisies}
  CTSaisie = blanc; {couleur texte saisies}
  NbChoixMnu = 10; {nombre maxi de choix dans un menu}
  NbCarChaine = 4; {nombre de caracteres d'une chaine}
  NbCarNom = 20; {nombre de caracteres du nom de configuration}
  NbBasculeSp = 3; {nombre de bascules speciales . Maxi 5}
  NbFichiers = 12;{nombre de fichier dans la liste}

type
  Chaine = array [1..NbCarChaine] of byte;
  Bascule = record
              On  : Chaine;
              Off : Chaine;
            end;
  Bascule2 = record
               Def : string[10];
               On  : Chaine;
               Off : Chaine;
             end;
  CfgImp = record
             Nom       : string[NbCarNom];

             Initial   : Chaine;
             RAZ       : Chaine;
             FinLigne  : Chaine;
             SautLigne : Chaine;
             NouvPage  : Chaine;
             LongPage  : Chaine;
             France    : Chaine;
             USA       : Chaine;
             Inter1_6  : Chaine;
             Inter1_8  : Chaine;
             InterN_72 : Chaine;

             ModeImp   : Chaine;
             Pica      : byte;
             Elite     : byte;
             Proportion: byte;
             Compresse : byte;
             Gras      : byte;
             DblFrappe : byte;
             Expanse   : byte;
             Italique  : byte;
             Souligne  : byte;

             Courrier  : Bascule;
             ExpanseLig: Bascule;
             Surligne  : Bascule;

             Special   : array [1..NbBasculeSp] of Bascule2;

           end;
  FConfig = file of CfgImp;

var
  Choix_Menu : TypChoix; {liste des choix d'un menu}
  Resultat : byte; {numro de ligne choisie dans un menu}
  Fin : boolean; {demande d'abandon du menu en cours}

  Imp_Actuelle : CfgImp; {configuration de l'imprimante actuelle}
  Fichier_Cfg  : FConfig; {fichier contenant les differentes configuration}

  Long_Page : real; {longueur du papier en cm}
  Imp_NomFichier : boolean; {impression du nom de fichier ?}
  NbLigneParPage : byte; {nombre de lignes par pages}
  LigneEnCours : byte; {numero de la ligne en cours}
  ValModeImp : byte; {valeur du mode d'impression}
  Ch_Init : str80; {Chaine d'initialisation}
  Ch_Titre : str80; {Chaine d'initialisation pour le titre}
  Ch_Texte : str80; {Chaine d'initialisation pour le texte}
  MargeH : byte; {Marge du haut en nombre de lignes}
  MargeB : byte; {Marge du bas en nombre de lignes}

  ListeFich : array [1..NbFichiers] of NomRep; {Liste des fichiers  imprimer}

procedure Fond;

IMPLEMENTATION

{----------------------------------------------------------------------------}

procedure Fond;

Begin
  CoulTexte(CTexte);
  CoulFond(CFond);
  RectTexte(2,1,79,25,2,true);
  Message(CTTitre,CFTitre,'  Listeur de fichiers   ',2,false);
  if Imp_Actuelle.Nom <> '' then
  Begin
    gotoxy(5,24);
    write(Imp_Actuelle.Nom);
  End;
  gotoxy(55,24);
  write('Cration A.JAFFRE 1994');
End;

{----------------------------------------------------------------------------}
procedure Init_Menu;

var
  N : byte;

Begin
  for N := 1 to NbChoixMnu do new(Choix_Menu[N]);
    Choix_Menu[N]^ := '';
End;


Begin
  Init_Menu;
  Imp_Actuelle.Nom := '';
  Long_Page := 30.48;
  Imp_NomFichier := true;
  Ch_Init := '2,3';
  Ch_Titre := '10,14,20';
  Ch_Texte := '10,20';
  MargeH := 1;
  MargeB := 1;
END.