unit ListImp;

{ Listeur de fichiers avec configuration imprimante }
{ Choix et impression des fichiers }

INTERFACE

uses
  crt,
  printer,
  Turbolib,
  Turboftr,
  ListGlob;

{----------------------------------------------------------------------------}

procedure ConfigPapier;
procedure Impression;

IMPLEMENTATION

Const
  YPosLongPage = 6;
  YPosImpFic   = 8;
  YPosChInit   = 10;
  YPosChTitre  = 12;
  YPosChTexte  = 14;
  YPosMargeH   = 16;
  YPosMargeB   = 18;

{----------------------------------------------------------------------------}

procedure EffaceBas;

var
  PosX : byte;

Begin
  CoulTexte(CTexte);
  CoulFond(CFond);
  gotoXY(4,21);
  for PosX := 4 to 70 do write(' ');
End;

{----------------------------------------------------------------------------}

procedure Saisie_Long_Page;

Begin
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  reel := Long_Page;
  Saisie(4,21,5,3,CFSaisie,CTSaisie,' Longueur de page :');
  if Abandon then exit;
  Long_Page := reel;
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  gotoXY(27,YPosLongPage);
  write(' ',Long_Page:5:2,' ');
  EffaceBas;
End;

{----------------------------------------------------------------------------}

procedure Saisie_Imp_Fichier;

Begin
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  if Imp_NomFichier then alpha := 'O'
                    else alpha := 'N';
  repeat
    Saisie(4,21,1,1,CFSaisie,CTSaisie,' Impression nom de fichier (O/N):');
    alpha := Majuscules(alpha);
  until (Abandon or (alpha = 'O') or (alpha = 'N'));
  if Abandon then exit;
  Imp_NomFichier := alpha = 'O';

  CoulTexte(CTSaisie);
  CoulFond(CFSaisie);
  gotoXY(27,YPosImpFic);
  if Imp_NomFichier then write(' O ')
                    else write(' N ');
  EffaceBas;
End;

{----------------------------------------------------------------------------}

procedure Saisie_Chaine_Init;

var
  PosX : byte;
  PosY : byte;
  Ch   : str80;

  procedure Affi(Texte : str80);

  Begin
    inc(PosY);
    gotoXY(PosX,PosY);
    write(Texte);
  End;

Begin
  CoulTexte(CTMenu);
  CoulFond(CFMenu);
  PosX := 55;
  PosY := 8;
  RectTexte(PosX,PosY,PosX + 22,PosY + 7,1,true);
  PosX := PosX + 2;
  Affi(' 1 France          ');
  Affi(' 2 USA             ');
  Affi('');
  Affi(' 3 Interligne 1/6  ');
  Affi(' 4 Interligne 1/8  ');
  Affi('5/N Interligne N/72');

  alpha := Ch_Init;
  Saisie(4,21,10,1,CFSaisie,CTSaisie,' Chaine initialisation :');
  if Abandon then exit;
  Ch_Init := alpha;

  CoulTexte(CTSaisie);
  CoulFond(CFSaisie);
  gotoXY(27,YPosChInit);
  Ch :=' ' + Ch_Init + ' ';
  write(Ch);
  CoulTexte(CTexte);
  CoulFond(CFond);
  for PosX := 1 to (27 - length(Ch)) do write(' ');
  EffaceBas;
End;

{----------------------------------------------------------------------------}

procedure Saisie_Chaine_Titre;

var
  PosX : byte;
  PosY : byte;
  Ch   : str80;
  Z    : byte;
  Tmp  : str40;

  procedure Affi(Texte : str80);

  Begin
    inc(PosY);
    gotoXY(PosX,PosY);
    write(Texte);
  End;

Begin
  CoulTexte(CTMenu);
  CoulFond(CFMenu);
  PosX := 55;
  PosY := 4;
  RectTexte(PosX,PosY,PosX + 22,PosY + 15 + NbBasculeSp,1,true);
  PosX := PosX + 2;

  Affi('10 Pica            ');
  Affi('11 Elite           ');
  Affi('12 Proportionnelle ');
  Affi('13 Compresse       ');
  Affi('14 Gras            ');
  Affi('15 Double frappe   ');
  Affi('16 Expans         ');
  Affi('17 Italique        ');
  Affi('18 Soulign        ');
  Affi('');
  Affi('20 Courrier        ');
  Affi('21 Brouillon       ');
  Affi('22 Expans 1 ligne ');
  Affi('23 Surlign        ');

  for Z := 1 to NbBasculeSp do
  Begin
    if Imp_Actuelle.Special[Z].Def <> '??????????' then
    Begin
      str((Z + 23),Tmp);
      Tmp := Tmp + ' ' + Imp_Actuelle.Special[Z].Def;
    End
    else Tmp := '';
    ElargiADte(Tmp,19);
    Affi(Tmp);
  End;

  alpha := Ch_Titre;
  Saisie(4,21,27,1,CFSaisie,CTSaisie,' Chaine init. titre :');
  if Abandon then exit;
  Ch_Titre := alpha;

  CoulTexte(CTexte);
  CoulFond(CFond);
  PosX := 55;
  PosY := 4;
  RectTexte(PosX,PosY,PosX + 22,PosY + 18,0,true);
  gotoXY(4,21);
  for PosX := 1 to 57 do write(' ');

  CoulTexte(CTSaisie);
  CoulFond(CFSaisie);
  gotoXY(27,YPosChTitre);
  Ch := ' ' + Ch_Titre + ' ';
  write(Ch);
  CoulTexte(CTexte);
  CoulFond(CFond);
  for PosX := 1 to (27 - length(Ch)) do write(' ');
  EffaceBas;
End;

{----------------------------------------------------------------------------}

procedure Saisie_Chaine_Texte;

var
  PosX : byte;
  PosY : byte;
  Ch   : str80;
  Z    : byte;
  Tmp  : str40;

  procedure Affi(Texte : str80);

  Begin
    inc(PosY);
    gotoXY(PosX,PosY);
    write(Texte);
  End;

Begin
  CoulTexte(CTMenu);
  CoulFond(CFMenu);
  PosX := 55;
  PosY := 4;
  RectTexte(PosX,PosY,PosX + 22,PosY + 13 + NbBasculeSp,1,true);
  PosX := PosX + 2;

  Affi('10 Pica            ');
  Affi('11 Elite           ');
  Affi('12 Proportionnelle ');
  Affi('13 Compresse       ');
  Affi('14 Gras            ');
  Affi('15 Double frappe   ');
  Affi('16 Expans         ');
  Affi('17 Italique        ');
  Affi('18 Soulign        ');
  Affi('');
  Affi('20 Courrier        ');
  Affi('21 Brouillon       ');

  for Z := 1 to NbBasculeSp do
  Begin
    if Imp_Actuelle.Special[Z].Def <> '??????????' then
    Begin
      str((Z + 23),Tmp);
      Tmp := Tmp + ' ' + Imp_Actuelle.Special[Z].Def;
    End
    else Tmp := '';
    ElargiADte(Tmp,19);
    Affi(Tmp);
  End;

  alpha := Ch_Texte;
  Saisie(4,21,15,1,CFSaisie,CTSaisie,' Chaine init. texte :');
  if Abandon then exit;
  Ch_Texte := alpha;

  CoulTexte(CTSaisie);
  CoulFond(CFSaisie);
  gotoXY(27,YPosChTexte);
  Ch := ' ' + Ch_Texte + ' ';
  write(Ch);
  CoulTexte(CTexte);
  CoulFond(CFond);
  for PosX := 1 to (27 - length(Ch)) do write(' ');
  EffaceBas;
End;

{----------------------------------------------------------------------------}

procedure Saisie_MargeH;

Begin
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  entier := MargeH;
  Saisie(4,21,2,2,CFSaisie,CTSaisie,' Marge haut (lignes):');
  if Abandon then exit;
  MargeH := entier;
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  gotoXY(27,YPosMargeH);
  write(' ',MargeH,' ');
  EffaceBas;
End;

{----------------------------------------------------------------------------}

procedure Saisie_MargeB;

Begin
  CoulFond(CFMenu);
  CoulTexte(CTMenu);
  entier := MargeB;
  Saisie(4,21,2,2,CFSaisie,CTSaisie,' Marge basse(lignes):');
  if Abandon then exit;
  MargeB := entier;
  CoulFond(CFSaisie);
  CoulTexte(CTSaisie);
  gotoXY(27,YPosMargeB);
  write(' ',MargeB,' ');
  EffaceBas;
End;

{----------------------------------------------------------------------------}

procedure ConfigPapier;

var
  X,Y: byte;

Begin
  if Imp_Actuelle.Nom = '' then Alerte('Pas d''imprimante slectione !!')
  else
  Begin
    Fond;
    Message(CTTitre,CFTitre,' Configuration papier ',3,false);
    Message(CTMenu,CFMenu,'  ESC = retour au menu prcdent  ',23,false);
    CoulFond(CFMenu);
    CoulTexte(CTMenu);
    X := 4;
    gotoXY(X,YPosLongPage);
    write(' Longueur de page (cm):');
    gotoXY(X,YPosImpFic);
    write(' Imp. nom fichier(O/N):');
    gotoXY(X,YPosChInit);
    write(' Chaine initialisation:');
    gotoXY(X,YPosChTitre);
    write(' Chaine pour le titre :');
    gotoXY(X,YPosChTexte);
    write(' Chaine pour le texte :');
    gotoXY(X,YPosMargeH);
    write(' Marge haute (lignes) :');
    gotoXY(X,YPosMargeB);
    write(' Marge basse (lignes) :');

    CoulFond(CFSaisie);
    CoulTexte(CTSaisie);
    X := 27;
    gotoXY(X,YPosLongPage);
    write(' ',Long_Page:5:2,' ');
    gotoXY(X,YPosImpFic);
    if Imp_NomFichier then write(' O ')
                    else write(' N ');
    X := 27;
    gotoXY(X,YPosChInit);
    write(' ',Ch_Init,' ');
    gotoXY(X,YPosChTitre);
    write(' ',Ch_Titre,' ');
    gotoXY(X,YPosChTexte);
    write(' ',Ch_Texte,' ');
    gotoXY(X,YPosMargeH);
    write(' ',MargeH,' ');
    gotoXY(X,YPosMargeB);
    write(' ',MargeB,' ');

    Saisie_Long_Page;
    if Abandon then exit;
    Saisie_Imp_Fichier;
    if Abandon then exit;
    Saisie_Chaine_Init;
    if Abandon then exit;
    Saisie_Chaine_Titre;
    if Abandon then exit;
    Saisie_Chaine_Texte;
    if Abandon then exit;
    Saisie_MargeH;
    if Abandon then exit;
    Saisie_MargeB;
  End;
End;

{----------------------------------------------------------------------------}

procedure CalculNbLigneParPage(Inter : real);

Begin
  NbLigneParPage := trunc((Long_Page / 2.54) * Inter);
  if MargeH > NbLigneParPage then MargeH := 0;
  if MargeB > NbLigneParPage then MargeB := 0;
  if (MargeH + MargeB) > NbLigneParPage then MargeB := 0;
End;

{----------------------------------------------------------------------------}

procedure ImpCar(Car : char);

Begin
  repeat until ImprimantePrete;
  write(lst,Car);
End;

{----------------------------------------------------------------------------}

procedure EnvoiLaChaine(LaChaine : Chaine);

var
  N : byte;

Begin
  for N := 1 to NbCarChaine do
  Begin
    if not (LaChaine[N] = 255) then ImpCar(chr(LaChaine[N]));
  End;
End;

{----------------------------------------------------------------------------}

procedure Envoi_ContreChaine(QuelleChaine : str80);

var
  Tmp : str80;
  Nb  : byte;
  NumChaine : byte;
  Code : integer;

Begin
  while length(QuelleChaine) <> 0 do
  Begin
    Nb := pos(',',QuelleChaine);
    if (Nb = 0) and (length(QuelleChaine)<>0) then
    Begin
      Tmp := QuelleChaine;
      QuelleChaine := '';
    End
    else
    Begin
      Tmp := copy(QuelleChaine,1,Nb);
      delete(QuelleChaine,1,Nb);
    End;
    val(Tmp,NumChaine,Code);
    with Imp_Actuelle do
    Begin
      case NumChaine of
        22 : EnvoiLaChaine(ExpanseLig.Off);
        23 : EnvoiLaChaine(Surligne.Off);
      end;
      if NumChaine in [24..(24 + NbBasculeSp)] then
         EnvoiLaChaine(Special[NumChaine - 23].Off);
    End;
  End;
End;

{----------------------------------------------------------------------------}

procedure Envoi_Chaine(QuelleChaine : str80);

var
  Tmp : str80;
  Nb  : byte;
  TmpVal : str80;
  Numerique : byte;
  NumChaine : byte;
  Code : integer;

Begin
  ValModeImp := 0;
  while length(QuelleChaine) <> 0 do
  Begin
    Nb := pos(',',QuelleChaine);
    if (Nb = 0) and (length(QuelleChaine)<>0) then
    Begin
      Tmp := QuelleChaine;
      QuelleChaine := '';
    End
    else
    Begin
      Tmp := copy(QuelleChaine,1,(Nb-1));
      delete(QuelleChaine,1,Nb);
    End;
    if pos('/',Tmp) <> 0 then
    Begin
      TmpVal := copy(Tmp,Pos('/',Tmp)+1,length(Tmp)-Pos('/',Tmp));
      val(TmpVal,Numerique,Code);
      Tmp := copy(Tmp,1,pos('/',Tmp)-1);
    End;
    val(Tmp,NumChaine,Code);
    with Imp_Actuelle do
    Begin
      case NumChaine of
        1  : EnvoiLaChaine(France);
        2  : EnvoiLaChaine(USA);
        3  : Begin
               EnvoiLaChaine(Inter1_6);
               CalculNbLigneParPage(6);
               EnvoiLaChaine(LongPage);
               ImpCar(chr(NbLigneParPage));
             End;
        4  : Begin
               EnvoiLaChaine(Inter1_8);
               CalculNbLigneParPage(8);
               EnvoiLaChaine(LongPage);
               ImpCar(chr(NbLigneParPage));
             End;
        5  : Begin
               EnvoiLaChaine(InterN_72);
               ImpCar(chr(Numerique));
               CalculNbLigneParPage((Numerique/72));
               EnvoiLaChaine(LongPage);
               ImpCar(chr(NbLigneParPage));
             End;

        10 : ValModeImp := ValModeImp + 0;
        11 : ValModeImp := ValModeImp + 1;
        12 : ValModeImp := ValModeImp + 2;
        13 : ValModeImp := ValModeImp + 4;
        14 : ValModeImp := ValModeImp + 8;
        15 : ValModeImp := ValModeImp + 16;
        16 : ValModeImp := ValModeImp + 32;
        17 : ValModeImp := ValModeImp + 64;
        18 : ValModeImp := ValModeImp + 128;

        20 : EnvoiLaChaine(Courrier.On);
        21 : EnvoiLaChaine(Courrier.Off);
        22 : EnvoiLaChaine(ExpanseLig.On);
        23 : EnvoiLaChaine(Surligne.On);
      end;
      if NumChaine in [24..(24 + NbBasculeSp)] then
         EnvoiLaChaine(Special[NumChaine - 23].On);
    End;
  End;
End;

{----------------------------------------------------------------------------}

procedure AffiListe (PosX,PosY : byte;Var Z : byte);

var
  Tmp : str80;

Begin
  gotoXY(PosX+2,PosY+Z+1);
  if length(ListeFich[Z]) > 37 then
       Tmp := copy(ListeFich[Z],Length(ListeFich[Z]) - 37,37)
  else Tmp := ListeFich[Z];
  write(Tmp);
End;

{----------------------------------------------------------------------------}

Procedure FinDeLigne;

Begin
  with Imp_Actuelle do
  Begin
    EnvoiLaChaine(FinLigne);
    EnvoiLaChaine(SautLigne);
  End;
  inc(LigneEnCours);
End;

{----------------------------------------------------------------------------}

Procedure NouvellePage;

Begin
  with Imp_Actuelle do EnvoiLaChaine(NouvPage);
End;

{----------------------------------------------------------------------------}

procedure ImprimeLigne(LaLigne : string);

var
  N : byte;

Begin
  for N := 1 to length(LaLigne) do ImpCar(LaLigne[N]);
  if LigneEnCours = (NbLigneParPage - 1 - MargeB) then
  Begin
    NouvellePage;
    LigneEnCours := 1;
    if MargeH <> 0 then
      for N := 1 to MargeH do FinDeLigne;
  End
  else FinDeLigne;
End;

{----------------------------------------------------------------------------}

procedure ImprimeFichier(Nom : str80);

var
  W : integer;
  Fichier_Texte : text;
  Ligne : string;
  Car : char;

Begin
  Abandon := false;
  LigneEnCours := 1;
  while not ImprimantePrete do Alerte('Vrifiez l''imprimante !');

  with Imp_Actuelle do
  Begin
    EnvoiLaChaine(RAZ);
    EnvoiLaChaine(Initial);
  End;
  Envoi_Chaine(Ch_Init);

  if MargeH <> 0 then
    for W := 1 to MargeH do FinDeLigne;

  if Imp_NomFichier then
  Begin
    Envoi_Chaine(Ch_Titre);
    EnvoiLaChaine(Imp_Actuelle.ModeImp);
    ImpCar(chr(ValModeImp));
    for W := 1 to length(Nom) do ImpCar(Nom[W]);
    FinDeLigne;
    Envoi_ContreChaine(Ch_Titre);
    EnvoiLaChaine(Imp_Actuelle.ModeImp);
    ImpCar(chr(0));
    FinDeLigne;
  End;

  Envoi_Chaine(Ch_Texte);
  EnvoiLaChaine(Imp_Actuelle.ModeImp);
  ImpCar(chr(ValModeImp));
  assign(Fichier_Texte,Nom);
  reset(Fichier_Texte);
  while not Eof(Fichier_Texte) do
  Begin
    readln(Fichier_Texte,Ligne);
    ImprimeLigne(Ligne);
    if keypressed then
    Begin
      Car := readkey;
      if Car = CarEsc then
      Begin
        Abandon := true;
        close(Fichier_Texte);
        exit;
      End;
    End;
  End;
  Envoi_ContreChaine(Ch_Texte);
  EnvoiLaChaine(Imp_Actuelle.ModeImp);
  ImpCar(chr(0));
  NouvellePage;
  close(Fichier_Texte);
End;

{----------------------------------------------------------------------------}

procedure Impression;

var
  Masque : NomFichier;
  MasqueOrg : NomFichier;
  Repertoire : NomRep;
  PosX,PosY : byte;
  Z : byte;

Begin
  if Imp_Actuelle.Nom = '' then Alerte('Pas d''imprimante slectione !!')
  else
  Begin
    Fond;
    Message(CTTitre,CFTitre,' Impression de fichiers ',3,false);
    Message(CTMenu,CFMenu,'  ESC = retour au menu prcdent  ',23,false);
    CalculNbLigneParPage(6);
    CoulDialogues := CFMenu;
    CoulTextes := CTMenu;
    Masque := '*.pas';
    Repertoire := RepPrg;
    Masque := DialogueTexte('Masque de choix :',Masque,12);
    if Masque = CarNul then exit;
    MasqueOrg := Masque;
    CoulTexte(CTMenu);
    CoulFond(CFMenu);
    PosX := 5;
    PosY := 5;
    RectTexte(PosX,PosY,PosX + 40,PosY + 14,2,true);
    gotoXY(PosX+4,PosY);
    write(' Liste des fichiers slectionns ');
    Message(CTMenu,CFMenu,'  ESC = lancement de l''impression  ',23,false);
    for Z := 1 to NbFichiers do ListeFich[Z] := '';
    Z := 0;
    while (Z < NbFichiers) and
          ChoixFichier(50,5,Repertoire,Masque,'Choix du fichier') do
    Begin
      inc(Z);
      ListeFich[Z] := Repertoire + Masque;
      AffiListe (PosX,PosY,Z);
      Masque := MasqueOrg;
    End;

    Z := 1;
    Message(CTTitre,CFTitre,'   ESC = ABANDON de l''impression   ',23,false);
    while (Z < NbFichiers) and (ListeFich[Z] <> '') do
    Begin
      CoulTexte(CTSaisie);
      CoulFond(CFSaisie);
      AffiListe (PosX,PosY,Z);
      ImprimeFichier(ListeFich[Z]);
      if Abandon then exit;
      CoulTexte(CFSaisie);
      CoulFond(CFMenu);
      AffiListe (PosX,PosY,Z);
      inc(Z);
    End;
  End;
End;

{----------------------------------------------------------------------------}

Begin

End.